# EV3Mindstorms CMake config file
#
# This file sets the following variables:
# EV3Mindstorms_FOUND - Always TRUE.
# EV3Mindstorms_INCLUDE_DIRS - Directories containing the EV3Mindstorms include files.
# EV3Mindstorms_IDL_DIRS - Directories containing the EV3Mindstorms IDL files.
# EV3Mindstorms_LIBRARIES - Libraries needed to use EV3Mindstorms.
# EV3Mindstorms_DEFINITIONS - Compiler flags for EV3Mindstorms.
# EV3Mindstorms_VERSION - The version of EV3Mindstorms found.
# EV3Mindstorms_VERSION_MAJOR - The major version of EV3Mindstorms found.
# EV3Mindstorms_VERSION_MINOR - The minor version of EV3Mindstorms found.
# EV3Mindstorms_VERSION_REVISION - The revision version of EV3Mindstorms found.
# EV3Mindstorms_VERSION_CANDIDATE - The candidate version of EV3Mindstorms found.

message(STATUS "Found EV3Mindstorms-1.0.0")
set(EV3Mindstorms_FOUND TRUE)

find_package(<dependency> REQUIRED)

#set(EV3Mindstorms_INCLUDE_DIRS
#    "/usr/local/include/ev3mindstorms-1"
#    ${<dependency>_INCLUDE_DIRS}
#    )
#
#set(EV3Mindstorms_IDL_DIRS
#    "/usr/local/include/ev3mindstorms-1/idl")
set(EV3Mindstorms_INCLUDE_DIRS
    "/usr/local/include/"
    ${<dependency>_INCLUDE_DIRS}
    )
set(EV3Mindstorms_IDL_DIRS
    "/usr/local/include//idl")


if(WIN32)
    set(EV3Mindstorms_LIBRARIES
        "/usr/local/components/lib/libev3mindstorms.a"
        ${<dependency>_LIBRARIES}
        )
else(WIN32)
    set(EV3Mindstorms_LIBRARIES
        "/usr/local/components/lib/libev3mindstorms.so"
        ${<dependency>_LIBRARIES}
        )
endif(WIN32)

set(EV3Mindstorms_DEFINITIONS ${<dependency>_DEFINITIONS})

set(EV3Mindstorms_VERSION 1.0.0)
set(EV3Mindstorms_VERSION_MAJOR 1)
set(EV3Mindstorms_VERSION_MINOR 0)
set(EV3Mindstorms_VERSION_REVISION 0)
set(EV3Mindstorms_VERSION_CANDIDATE )

